module Absyn(Exp(..), Def(..), mkApp2, mkApp3, mkIf) where

import Basic


-- Expressions.
-- Ranged over by e.

data Exp = LitInt Int		-- Literal integer
         | Prim Name		-- Primitive
         | Var Id		-- Variable
         | App Exp Exp		-- Application, exp1 exp2
         | Letrec [Def] Exp	-- Recursive definition, letrec defs in exp
         -- deriving Show


-- Definitions.
-- Ranged over by d.

data Def = VarDef Id Exp	-- x = exp
         | FunDef Id [Id] Exp	-- f x1 ... xn = exp
         -- deriving Show


-- Operations.

mkApp2 f a1 a2 = (App (App f a1) a2)

mkApp3 f a1 a2 a3 = (App (App (App f a1) a2) a3)

mkIf c e1 e2 = mkApp3 (Prim 'if') c e1 e2
