module Main where

import MiniF
import Prelude hiding ((.))

(.) f g x = f (g x)

dtake = FunDef "take" ["n", "xs"]
            (mkIf (App (Prim 'null') (Var "xs"))
                  (Prim 'Null')
                  (mkIf (mkApp2 (Prim '<=') (Var "n") (LitInt 0)) 
                        (Prim 'Null')
                        (mkApp2 (Prim 'Cons')
                                (App (Prim 'head') (Var "xs"))
                                (mkApp2 (Var "take")
                                        (mkApp2 (Prim '- ')
                                                (Var "n")
                                                (LitInt 1))
                                        (App (Prim 'tail') (Var "xs"))))))

dfilter = FunDef "filter" ["p", "a"]
              (mkIf (App (Prim 'null') (Var "a"))
                    (Prim 'Null')
                    (Letrec
                         [ VarDef "x" (App (Prim 'head') (Var "a")),
                           VarDef "xs" (App (Prim 'tail') (Var "a")) ]
                         (mkIf (App (Var "p") (Var "x"))
                               (mkApp2 (Prim 'Cons')
                                       (Var "x")
                                       (mkApp2 (Var "filter")
                                               (Var "p")
                                               (Var "xs")))
                               (mkApp2 (Var "filter") (Var "p") (Var "xs")))))

dfrom = FunDef "from" ["n"]
            (mkApp2 (Prim 'Cons')
                    (Var "n")
                    (App (Var "from")
                         (mkApp2 (Prim '+ ') (Var "n") (LitInt 1))))

dsieve = FunDef "sieve" ["a"]
             (Letrec
                  [ VarDef "x" (App (Prim 'head') (Var "a")),
                    VarDef "xs" (App (Prim 'tail') (Var "a")),
                    FunDef "notdivx" ["y"]
                        (mkApp2 (Prim '/=')
                                (mkApp2 (Prim 'mod') (Var "y") (Var "x"))
                                (LitInt 0)) ]
                  (mkApp2 (Prim 'Cons')
                          (Var "x")
                          (App (Var "sieve")
			       (mkApp2 (Var "filter") 
			               (Var "notdivx")
				       (Var "xs")))))

dones = VarDef "ones" (mkApp2 (Prim 'Cons') (LitInt 1) (Var "ones"))

dprimes = VarDef "primes" (App (Var "sieve") (App (Var "from") (LitInt 2)))

defs = [dtake, dfilter, dfrom, dsieve, dprimes]
prog = Letrec defs (mkApp2 (Var "take") (LitInt 500) (Var "primes"))


main = print (vfE prog emptyEnv) ""

print (Int n) = showString "(Int " . shows n . showString ")"
print (Ctr n xs) = showString "(Ctr "
		   . shows n
		   . showChar ' '
		   . printList xs
		   . showString ")"
print (Fun n _) = showString "(Fun " . shows n . showString " <function>)"
print (PAp n _ xs) = showString "(PAp "
		     . shows n
		     . showString " <function> "
		     . printList xs
		     . showString ")"

printList [] = showString "[]"
printList (x:xs) = showString "[" . print x . printList1 xs

printList1 [] = showString "]"
printList1 (x:xs) = showString "," . print x . printList1 xs
