module MiniF (module Basic,
	      module Absyn,
	      module Val,
	      module Env,
	      module Prim,
	      vfE) where

import Basic
import Absyn
import Val
import Env
import Prim


vfE :: Exp -> Env -> Val
vfE (LitInt n)  env = Int n
vfE (Prim n)    env = vfP n
vfE (Var i)     env = env i
vfE (App e1 e2) env = apply (vfE e1 env) (vfE e2 env)
vfE (Letrec ds e) env = vfE e env'
    where
        env' = fix (vfE_Lambda1 ds env)	-- OK, Bug 1
--        env' = fix (vfE_Lambda1 ds env')	-- Bug 2

vfE_Lambda1 ds env env' = updEnv (elaborate ds env') env	-- OK
-- vfE_Lambda1 ds env env' = updEnv (elaborate ds env) env'	-- Bug 1
-- vfE_Lambda1 ds env' env = updEnv (elaborate ds env') env	-- Bug 2


elaborate []		       env = []
elaborate (VarDef i e    : ds) env = (i, vfE e env) : elaborate ds env
elaborate (FunDef i is e : ds) env =
    (i, Fun (length is) (elaborate_Lambda1 e is env))
    : elaborate ds env

elaborate_Lambda1 e is env as = vfE e (updEnv (zip is as) env)
