module Val(Val(..), apply) where

import Basic


-- Expressible values.
-- Ranged over by a, b, f.

data Val = Int Int                       -- Integer
         | Ctr Name [Val]		 -- Constructed value
         | Fun Int ([Val] -> Val)	 -- Function
         | PAp Int ([Val] -> Val) [Val]	 -- Partial application
	 -- deriving Show


-- Operations.

apply :: Val -> Val -> Val
apply (Fun n f)    a | n == 1 = f [a]
		     | n > 1  = PAp (n - 1) f [a]
apply (PAp n f as) a | n == 1 = f (as ++ [a])
		     | n > 1  = PAp (n - 1) f (as ++ [a])
apply _		   _          = error "Application of non-functional value."
