module Main where

import Prelude hiding ((.))
(.) f g x = f (g x)

data Tree a = Tip a | (Tree a) :^: (Tree a) -- deriving Show


sort []       = []
sort (x : xs) = insert x (sort xs)


insert x [] = [x]				-- [] => Good bug
insert x xxs@(x' : xs) | x < x'    = x : xxs
		       | otherwise = x' : insert x xs


sortTree t = t_tree
    where
        (t_stips, t_ssorted, t_tree) = sortTree' t t_itips t_isorted
	t_itips	  = []
	t_isorted = sort t_stips
	

sortTree' (Tip a) t_itips t_isorted = (t_stips, t_ssorted, t_tree)
    where
        t_stips   = a : t_itips
	t_ssorted = tail t_isorted
	t_tree    = Tip (head t_isorted)	-- t_ssorted => good bug
sortTree' (l :^: r) t_itips t_isorted = (t_stips, t_ssorted, t_tree)
    where
        (l_stips, l_ssorted, l_tree) = sortTree' l l_itips l_isorted
	(r_stips, r_ssorted, r_tree) = sortTree' r r_itips r_isorted
	r_itips	  = t_itips
	l_itips	  = r_stips			-- l_stips => Good bug
	t_stips   = l_stips
	l_isorted = t_isorted			-- t_ssorted => Black hole
	r_isorted = l_ssorted
	t_ssorted = r_ssorted
	t_tree    = l_tree :^: r_tree


aTree = ((Tip 7) :^: ((Tip 2) :^: (Tip 5))) :^: ((Tip 3) :^: (Tip 1))


main = showTree (sortTree aTree) "\n"

showTree :: Show a => Tree a -> ShowS
showTree (Tip a)   = showString "(Tip " . showString (show a) . showChar ')'
showTree (l :^: r) = showChar '('
		     . showTree l
		     . showString " :^: "
		     . showTree r
		     . showChar ')'
