! ****************************************************************************
! *                 F R E J A   R U N T I M E   S Y S T E M                  *
! *									     *
! *	Name:		RTS Defs					     *
! *	File name:	rts_defs.h				             *
! *	Purpose:	Common definitions for the runtime system.     	     *
! *	Programmer:	Henrik Nilsson					     *
! *	Version:	1.2						     *
! *	Date:		1999/03/08					     *
! *									     *
! ****************************************************************************

#ifndef _RTS_DEFS_H
#define _RTS_DEFS_H

#include "obj_types.h"
#include "trace_classes.h"
#include "rts_defs1.h"
#include "rts_defs2.h"

! Registers
#define FWDTAG %g2
#define SCAN %g3
#define TB %g4
#define HB %g5
#define HP %g6
#define HL %g7
#define VFP %i4
#define SFP %i5
#define FP %fp
#define VSP %o4
#define SSP %o5
#define SP %sp
#define LINK %o7


! Descriptor Table Offsets
#define DTO_ARITY 0
#define DTO_SIZE 0
#define DTO_INFO 4
#define DTO_MTHDTBL 8
#define DTO_MOVE 12
#define DTO_RELOCATE 16
#define DTO_EVALUATE 20
#define DTO_CONNO 28
#define DTO_CONTBL 28
#define DTO_NCONS 32
#define DTO_UNWIND 40
#define DTO_EXECUTE 48
#define DTO_COMPARE 64


! Local variables (Frame Pointer Offsets & sizes)
#define FPO_ASA 68
#define VRSA_SIZE 160
#define FPO_VRSA (0 - VRSA_SIZE)

#endif
