/*****************************************************************************
 *                  F R E J A   R U N T I M E   S Y S T E M                  *
 *									     *
 *	Name:		RTS Defs 2					     *
 *	File name:	rts_defs2.h				             *
 *	Purpose:	The architecture-independent part of		     *
 *			$(ARCH)/rts_defs.h				     * 
 *	Programmer:	Henrik Nilsson					     *
 *	Version:	1.1						     *
 *	Date:		1999/03/08					     *
 *									     *
 *****************************************************************************/

/* Reasonably architecture indenpendent? Perhaps this file should be generated
 * from a C-program based on the C-definitions (using offsetof).
 */

#ifndef _RTS_DEFS2_H
#define _RTS_DEFS2_H

/* Information Record Offests. Must agree with the C type obj_info (see rts.h).
 * Note that object type definitions are imported from obj_types.h.
 */
#define IRO_OBJ_TYPE 0
#define IRO_FUN_QUALIFIERS 4
#define IRO_FUN_NAME 8
#define IRO_FUN_SOURCE_FILE 12
#define IRO_FUN_FIRST_LINE 16
#define IRO_FUN_FIRST_COLUMN 20
#define IRO_FUN_LAST_LINE 24
#define IRO_FUN_LAST_COLUMN 28
#define IRO_FUN_ARITY 32
#define IRO_FUN_PRECEDENCE 36
#define IRO_FUN_N_FREE_VARS 40
#define IRO_FUN_FREE_VARS 44
#define IRO_FUN_TIP 48
#define IRO_CON_QUALIFIERS 4
#define IRO_CON_TYPE_NAME 8
#define IRO_CON_NAME 12
#define IRO_CON_ARITY 16
#define IRO_CON_NUMBER 20
#define IRO_CON_PRECEDENCE 24
#define IRO_CON_FIELDS 28
#define IRO_ENUM_QUALIFIERS 4
#define IRO_ENUM_TYPE_NAME 8
#define IRO_ENUM_CON_NAMES 12
#define IRO_ENUM_CON_TBL 16


/* Debugger-related definitions. */

/* Trace Info Offsets. Must agree with the C type trace_info (see rts.h). */
#define TIO_INITIAL_TC 0
#define TIO_MUST_TRACE 4
#define TIO_RECURSIVE 8
#define TIO_FUN_GROUP 12
#define TIO_STARTING_POINT 16
#define TIO_TRACE_CLASS 20

#endif
